--- use of underscore
id : (A:Set) -> A -> A
id = \A -> \a -> a
k  : (A:Set) -> (B:Set) -> A -> B -> A
k  = \A -> \B -> \a -> \_ -> a
-- Not allowed anymore
--voidForall : (_:Set) -> Set -> Set
--voidForall  = \_ -> \A -> A

-- alpha
id1 : ((A:Set) -> A) -> ((A1:Set) -> A1)
id1 = \ x -> x
id2 : ((A0:Set) -> A0) -> ((A:Set) -> A)
id2 = \ x -> x

-- use of versions

-- funny message
-- ;ver : (A:Set) -> ((A1:Set) -> A1) -> ((A1:Set) -> A)
--   = \ A -> \ x -> x
-- | When    checking that x has type (A : Set) -> A,
-- |         the inferred type (A : Set) -> A is not a subtype of
--           (A : Set) -> A
-- | because identifier A1 is not equal to A.

ver : (A:Set) -> ((A0:Set) -> A0) -> ((A1:Set) -> A1)
ver = \ A -> \ x -> x


-- shadowing allowed

-- shadowing should be allowed here ?!
-- ;shadow : (A:Set) -> ((A:Set) -> A) -> ((A:Set) -> A)
--   = \ A -> \ x -> x
-- | When    inferring the type of (A : Set) -> A,
-- |         a variable is shadowed
-- | because the variable A has already been bound.

Empty : Type 
Empty = (A:Set) -> A
shadow1 : (A:Set) -> Empty -> Empty
shadow1 = \ A -> \ x -> x
shadow2 : (A:Set) -> Empty -> (A1:Set) -> A1
shadow2 = \ A -> \ x -> x

-- ;shadow3 : (A:Set) -> Empty -> (A223874627:Set) -> A
--   = \ A -> \ x -> x
shadow3 : (A:Set) -> Empty -> (A1:Set) -> A1
shadow3 = \ A -> \ x -> x


--- shadowing not allowed
--- bla : Type
---   = (A:Set) -> (P:A->Set) -> (A:A) -> P A
bla : Type
bla  = (A:Set) -> (P:A->Set)  -> (A:Set) -> (a:A) -> P a
bla : Type
bla  = (A:Set) -> (P:A->Set) -> (A:A) -> (A:Set) -> P A
coerce : (A:Set) -> (B:Set) -> A -> B
coerce = \A -> \A -> \a -> a 

