
-- # import nat
-- # import vec

data Tree (A : Set) : Nat -> Set where
  leaf		    : A -> Tree A 1
  node (n, m : Nat) : Tree A n -> Tree A m -> Tree A (n + m)

flatten (A : Set)(n : Nat) : Tree A n -> Vec A n
flatten (leaf x)    = [x]
flatten (node l r)  = flatten l ++ flatten r

{-

This doesn't work:

  flatten (A : Set) : (n : Nat) -> Tree A n -> Vec A n
  flatten 1	  (leaf x)    = [x]
  flatten (n + m) (node l r)  = flatten n l ++ flatten m r

There has to be at least one hard occurrence of each named variable.

-}

flatten' (A : Set) : (n : Nat) -> Tree A n -> Vec A n
flatten' 1	 (leaf x)	    = [x]
flatten' (n + m) (node {n} {m} l r) = flatten' n l ++ flatten' m r

